
%
%   Generate all cross reference data for all user commands
%

Procedure   XrefInit( in XRDocName, in pDocType, inout pResult ) \
              local (DialogResult)

set save

let pResult = $true

delete all XRefObjs

set checksets off
set input format normal
set output format normal

if XRDocName = ''
   if pDocType = ""
      find all documents wh doctype not in ("device", "data") ->xrefdocset
   else
      find all documents wh doctype = pDocType ->xrefdocset
   endif
else
   if pDocType = ""
      find all documents wh docname = XRDocName? \
                 and DocType not in ("device","data") -> xrefdocset
   else
      find all documents wh docname = XRDocName? \
                 and DocType = pDocType -> xrefdocset
   endif
endif

while $setcount > 0
   let <docname> = $trim( docname )

   if fXRef.CBConfirm = $true
      let DialogResult = $messagebox ( \
             "Generate XREF for #<docname>?", \
             cQUESTIONMSG, \
             cYESNOCANCELSTYLE, \
             cDEFAULTBUTTON1, \
             "Program Cross Reference")
      if DialogResult = $toalpha("Cancel", 6)
         let pResult = $false
         break
      elseif DialogResult = $toalpha("No", 2)
         goto LoopEnd
      endif
   endif

   set output XRefDoc
   set xref on
   set errors off
   set warnings off
   parse #<docname>
   set errors on
   set warnings on
   set xref off
   set output terminal
   add XRefObjs from XRefDoc

LoopEnd:
   set currentset xrefdocset
   next xrefdocset
   let $setcount = $setcount - 1
endwhile

set checksets on
set restore

endprocedure
