%% mZOMCreate

on BREAK
   let vZOMBreak = $true
   if '#<SetSave>' = $true
      SET RESTORE
   endif
   goto ExitProc
endon

let <SetSave> = $true
SET SAVE
set messages off
set dependency on

let <ObjectType>   = $trim(vObjectType) \
    <ObjectName>   = $trim(vObjectName) \
    <ObjOwnerName> = $trim(vObjectOwnerName) \
    <ObjDirName>   = $trim(vObjectDirName) \
    <CreateOption> = '' \
    <FileNumOption>= ''

%% Access the object's directory in update mode
if $dirpath() not like '%;#<ObjDirName>(U);%'
   if $dirpath() like '%;#<ObjDirName>(R);%'
      release #<ObjDirName>
   endif
   access #<ObjDirName> update
endif

if vObjectType = FLDOBJTYPE
   create #<ObjectType> #<ObjOwnerName> #<ObjectName> in #<ObjDirName>
   goto ExitProc
elseif '#<UseExistingFileNum>' = $true and \
   vObjectType in (ENTOBJTYPE, RELOBJTYPE, DIROBJTYPE)
   find 1 ObjList where ObjectKey = vObjectKey
   let <FileNumOption> = $concat('$fn ', ObjList.Filenumber)
endif

CreateIt:
let $LastErrCode = $null \
    $LastErrLevel = $null % checked in pZOMCreate

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if vGeneralTrace = $True
   set output errtrace append
   out "creating  #<ObjectType> #<ObjectName> in #<ObjDirName> #<CreateOption> #<FileNumOption>"
   set output terminal
elseif vGeneralTrace = '2'
   out "creating  #<ObjectType> #<ObjectName> in #<ObjDirName> #<CreateOption> #<FileNumOption>"
endif
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Definitely, this is hacking! However, the code is so convoluted and we are replacing DC
% by IDE that we are not going to care about clean code at this stage.
% We are doing this to avoid the error where the file is still there after the erase.
% Bressan: Commented out for now. It's wrong anyway because it does not address relationships
% with fields. It might be possible that recent ZimServer fixes corrected this situation.
%if "#<ObjectType>" = "EntitySet" and $InTransaction = $true
%   endtransaction
%endif

create #<ObjectType> #<ObjectName> in #<ObjDirName> #<CreateOption> #<FileNumOption>

if $lasterrcode in (1036, 7866) % N.B. "On Error" trap won't work here
   %% Directory, Entity, or Relationship file already exists.
   set escapechar on

   if $toupper('#<ObjectType>') not in ('FORM','DISPLAY','MENU','WINDOW')

      if '#<FileNumOption>' > ''
         let <Response> = $messagebox($concat( \
               'Unable to create "#<ObjectName>" with file number "', \
                $trim($substring('#<FileNumOption>',5,4)), '"\0d', \
               'Create it with the next default file number?'), \
                cErrorMsg, cYesNoStyle, cDefaultButton1, \
                'ZOM Create') \
            <FileNumOption> = ''

         if '#<Reponse>' = 'YES'
            goto CreateIt
         else
            goto ExitProc
         endif

      endif

      if '#<ZOMCreateOverwrite>' = ''
         let <ZOMCreateOverwrite> = $messagebox($concat( \
                   'There are existing ZIMnnnn files\0d', \
                   'Overwrite ALL of them?'), \
                    cErrorMsg, cYesNoStyle, cDefaultButton1, \
                    'ZOM Create')
      endif

      if '#<ZOMCreateOverwrite>' = 'NO'
         let <Response> = $messagebox($concat('The file "', \
                    $substring($lasterrmessage,                            \
                    $position($lasterrmessage, '("')+2,                \
                    $position($lasterrmessage, '")') - $position($lasterrmessage, '("') -2), \
                    '" already exists.\0dOverwrite it?'),              \
                    cErrorMsg, cYesNoStyle, cDefaultButton1,           \
                    'ZOM Create')
       else
         let <Response> = 'YES'
       endif

       if '#<Response>' = 'YES'
           if "#<CreateOption>" = 'delete'
               let <Response> = $messagebox($concat(                       \
                       'Zim is not being able to remove the file - ',  \
                    $substring($lasterrmessage,                            \
                    $position($lasterrmessage, '("')+2,                \
                    $position($lasterrmessage, '")') - $position($lasterrmessage, '("') -2), \
                    ' -\0d Please, Check file permissions. - Operation aborted. '),                \
                    cErrorMsg, cOKStyle, cDefaultButton1,          \
                    'ZOM Create')
               goto ExitProc
           endif

         let <CreateOption> = 'delete'
         goto CreateIt
       endif

   endif

endif
if vObjectType in (ENTOBJTYPE,RELOBJTYPE)                       %%%  Are there SEQ fields in the object?
   let vZOMSequenceNumber = $False
   compute 1 Fields where OwnerName = vObjectName and      \
                          DirName   = vObjectDirName  and  \
                          Reqd      = 'SEQ'                \
                    eval (let vZOMSequenceNumber = $True)
   if vZOMSequenceNumber = $True                                %%% Is there a SEQ field ?
      set SequenceNumber #<ObjDirName>.#<ObjectName> ON         %%% Checking if the sequence file already exists
      if $ZimSeqNum is Null                                     %%% File does not exist ($ZimSeqNum is Null
         set SequenceNumber #<ObjDirName>.#<ObjectName> 1       %%% Create it using the SET command
      endif
   endif
elseif vObjectType = DIROBJTYPE
   compute 1 Dirs \
      where Dirs.ObjectKey = vObjectKey and Dirs.Foreign = 'yes' \
      evaluate ('')
   if $membercount = 0
      if $dirpath() not like '%;#<ObjectName>(U);%'
         if $dirpath() like '%;#<ObjectName>(R);%'
            release #<ObjectName>
         endif
      endif
      access #<ObjectName> update
   endif
endif

ExitProc:

SET RESTORE
