%% tZOMDocDDBoot

on BREAK
   let vZOMBreak = $true
   RETURN
endon

find 1 Documents \
   where Documents.ObjectKey = vObjectKey

let \
   <UniqueName> = \
      {$concat('"', $trim(Documents.UniqueDocDirName), '"'), '$null'} \
   <DocName> = {$concat('"', $trim(Documents.DocName), '"'), '$null'} \
    \ % N.B. FileName must use single quotes because may contain (")
   <FileName> = {$concat("'", $trim(Documents.FileName), "'"), '$null'} \
   <DocType> = {$concat('"', $trim(Documents.DocType), '"'), '$null'} \
   <AvgSize> = {$concat('"', $trim(Documents.AvgSize), '"'), '$null'} \
   <DirName> = {$concat('"', $trim(Documents.DirName), '"'), '$null'} \
   <DocPerUser> = {$concat('"', $trim(Documents.DocPerUser), '"'), '$null'} \ %%Zim 8.0
   <ObjectKey> = {$concat('"', vObjectKey, '"') \
      where vZOMOptions[ZOMOOPTION] is not $null, '$null'}

if vZOMOptions[ZOMUOPTION] is not $null
   let <BootAction> = 'Updating'
<<
   delete all Documents DocFields Fields \
      where UniqueDocDirName = #<UniqueName> \
      keep Fields
   delete Documents \
      where UniqueDocDirName = #<UniqueName>
>>
else
   let <BootAction> = 'Adding'
endif

<<
   set escapechar off
   add 1 Documents \
      let \
         Documents.DocName = #<DocName> \
         Documents.FileName = #<FileName> \
         Documents.DocType = #<DocType> \
         Documents.AvgSize = #<AvgSize> \
         Documents.DirName = #<DirName> \
         Documents.DocPerUser = #<DocPeruser> \ %%Zim 8.0
         Documents.ObjectKey = #<ObjectKey>

>>

find all Documents DocFields Fields \
   where Documents.ObjectKey = vObjectKey \
   sorted by Fields.SN

if $setcount > 0
   generate tZOMFldDDBoot
endif

<<
   set escapechar on

>>
