%% ZOMEnable - Initialize the ZOM environment.
on error
   out "error ........" $lasterrcode
   SET RESTORE
   RETURN
endon

if vZOMEnabled = $true
   RETURN
endif

% We are pretty much good at this stage.
let vZOMEnabled = $true

SET SAVE
set messages off
set membercount off

% Create ZOMFields if does not exist.
% Should be removed as soon as we change versions.
if $exist$( 'ZIM', 'ZomFields', 12 ) = $false
   add 1 Roles let RoleName = 'ZomFields' OwnerName = 'Fields' RoleCondition = '' DirName = 'ZIM'
@syser
   create role ZOMFields in ZIM $sn 878
   delete roles where RoleName = 'ZOMFields' and DirName = 'ZIM'
endif

if $dirpath() not like '%;$DevCen(%'
   access $DevCen
endif

if $dirpath() not like '%;$ZOM(%'
    access $ZOM
endif

if $dirpath() not like '%;$Utils(%'
   access $Utils
endif

if $exist$("ZIM", "$DeployServices", 2) = $true and $dirpath() not like '%;$DeployServices(%'
   access $DeployServices
endif

if $dirpath() not like '%;$CompDevCen(%'
   access $CompDevCen
endif

% ZOM is talking to whom?
if "#<1>" = "ZIMIDE"
   let vZOMType = ZOMWITHIDE
elseif $ZIMProduct = 9
   let vZOMType = ZOMWITHAGT
else
   let vZOMType = ""
endif

% Checking the current version of Services.
let vZomKeyCounter = 0
if $DCRevision < $CurrentDCRevision or vZomOperationMode = "DC"
   UpdateDC($transmitkey)
   if $transmitkey <> "OK"
      if NOT vZOMType = ""
         let $LastErrCode = 5820
         let $LastErrMessage = "Unable to upgrade ZOM in background. Invoke your client session instead."
         if vZOMType = ZOMWITHAGT
            set output errtrace
            out "Unable to upgrade ZOM in background. Invoke your client session instead."
         endif
      endif
      let vZOMEnabled = $false
      SET RESTORE
      RETURN
   endif
endif

if $dirpath() not like '%;$DeployServices(%'
   access $DeployServices
endif

if $dirpath() not like '%;$CompDevCen(%'
   access $CompDevCen
endif

find 1 pZOMInit
if $setcount = 0
   pZOMConfig('RESET')
endif

pZOMInit()

%% see if there are any objects! If not, assume ZOM never enabled.
compute 1 ObjList evaluate ("")
if $membercount = 0
   pZOMDisplayInit( "Activating ZOM" )
   pZOMRegisterAll('REKEY') % Make sure all objects are registered
   pZOMDisplayEnd()
   set escapechar on
   IF vZomOperationMode <> "DC"      %%% Buidling DC?  LAT Mar/2002
      ZOMTouch * ;i
   endif
else
   pZOMRegisterAll('') % Make sure all objects are registered
endif
%%          Set the Keyword $ZimInit to all objects initially created
let vDC1 = vZOMDisplay
let vZOMDisplay = "N"
zomset +k$ziminit ;k$ziminit!
zomset Black,Blue,Brown ,Button1,Button2,Button3,Button4,Button5,Button6,CActiveBorder,CActiveCaption,CAppWorkSpace,CButtonFace,CButtonHighlight,CButtonShadow,CButtonText,CCaptionText, ;k$ziminit
zomset CGrayText,CGreyText, CHighlightColor, CHighlightText,CInactivCaptionTxt,CInactiveBorder,CInactiveCaption,CMenuColor,CMenuTextColor,CScrollBarColor,CWindowBackground,CWindowColor ;k$ziminit
zomset CWindowFrame,CWindowText,Cyan,DarkGray,DarkGrey,Esc,Escape,F1?,F2?,F3?,F4?,F5?,F6?,F7?,F8?,F9?,F100,Green,Home,JumpDown,JumpLeft,JumpRight,JumpUp,LightBlue,LightCyan,LightGray,LightGreen ;k$ziminit
zomset LightGrey,LightMagenta,LightRed,Magenta,PageDown,PageUp,Red,TabBack,TabForward,White,Yellow,ZIM,aft,cft,clipboard,descerr,errtrace,explerr,halt,printer,reload,servbye,servprof,stderr ;k$ziminit
zomset stdin,stdout,terminal,unload,zimbye,zimload,zimprof,zimsave,pzomcall,rep$* ;k$ziminit
let vZOMDisplay = vDC1

% For existing databases, pZOMCall is out of place and needs to be corrected.
% Sometime in the future, this fix can be removed.
find Docs where DocName = "pZOMCall"
if $setcount = 0 and $exist$('ZIM', 'pZOMCall', 9) = $true
   % This seems to be an old database that needs the fix.
   erase document pZOMCall
   add 1 Docs let DocName = 'pZOMCall' FileName = '#pzomcall.cmd' DirName = 'ZIM' objectkey=$Null
   create document pZOMCall
   ZOMTouch pZomCall
   let vZOMDisplay = "N"
   zomset pZOMCall ; K $ZimInit
   let vZOMDisplay = vDC1
endif

SET RESTORE
