%% tZOMEntDDBoot --- Zim Version 8
%        Included EntPerUser attribute
on BREAK
   let vZOMBreak = $true
   RETURN
endon

find 1 EntitySets \
   where EntitySets.ObjectKey = vObjectKey

let \
   <UniqueName> = \
      {$concat('"', $trim(EntitySets.UniqueEntDirName), '"'), '$null'} \
   <EntName> = {$concat('"', $trim(EntitySets.EntName), '"'), '$null'} \
   <EntType> = {$concat('"', $trim(EntitySets.EntType), '"'), '$null'} \
   <AvgSize> = {$concat('"', $trim(EntitySets.AvgSize), '"'), '$null'} \
   <DirName> = {$concat('"', $trim(EntitySets.DirName), '"'), '$null'} \
   <EntPerUser> = {$concat('"', $trim(EntitySets.EntPerUser), '"'), '$null'} \   %%Zim 8.0
   <RemoteName> = {$concat('"', $trim(EntitySets.RemoteName), '"'), '$null'} \
   <RemoteOwnerName> = \
      {$concat('"', $trim(EntitySets.RemoteOwnerName), '"'), '$null'} \
   <ObjectKey> = {$concat('"', vObjectKey, '"') \
      where vZOMOptions[ZOMOOPTION] is not $null, '$null'}

if vZOMOptions[ZOMUOPTION] is not $null
   let <BootAction> = 'Updating'
<<
   delete all EntitySets EntFields Fields \
      where UniqueEntDirName = #<UniqueName> \
      keep Fields
   delete EntitySets \
      where UniqueEntDirName = #<UniqueName>
>>
else
   let <BootAction> = 'Adding'
endif

<<
   set escapechar off
   add 1 EntitySets \
      let \
         EntitySets.EntName = #<EntName> \
         EntitySets.EntType = #<EntType> \
         EntitySets.AvgSize = #<AvgSize> \
         EntitySets.RemoteName = #<RemoteName> \
         EntitySets.RemoteOwnerName = #<RemoteOwnerName> \
         EntitySets.DirName = #<DirName> \
         EntitySets.EntPerUser = #<EntPerUser> \                              %%Zim 8.0
         EntitySets.ObjectKey = #<ObjectKey>

>>

find all EntitySets EntFields Fields \
   where EntitySets.ObjectKey = vObjectKey \
   sorted by Fields.SN

generate tZOMFldDDBoot

<<
   set escapechar on

>>
