procedure mZOMReName() \
   local(vlSetSave, vlZOFStructure)

on BREAK
   let vZOMBreak = $true
   if vlSetSave = $true
      SET RESTORE
   endif
   goto ExitProc
endon

   let vlSetSave = $true
   SET SAVE
   set messages off
   set dependency on

   let <ObjectType> = $trim(vObjectType) \
       <ObjectName> = $trim(vObjectName) \
       <ObjOwnerName> = $trim(vObjectOwnerName) \
       <ObjDirName> = $trim(vObjectDirName) \
       <NewObjName> = $trim(vZOMTarget)

   let $LastErrCode = $null

   if vObjectType in (DISPOBJTYPE, FORMOBJTYPE, MENUOBJTYPE, WINOBJTYPE)
      %% N.B. Don't use rename because WdgTag may have to be changed as well.
      erase #<ObjectType> #<ObjDirName>.#<ObjectName> from #<ObjDirName>
      if $LastErrCode is $null
         create #<ObjectType> #<NewObjName> in #<ObjDirName>
      endif
   elseif vObjectType not in (DIROBJTYPE, FLDOBJTYPE)
      rename #<ObjectType> #<ObjDirName>.#<ObjectName> as #<NewObjName> in #<ObjDirName>
      if vObjectType = DOCOBJTYPE

         %% If this is a Zim Class then derive it's attribute structure name
         %% First check for an explict name
         compute 1 Documents DocFields Fields \
           where DocName = vZOMTarget and Documents.DirName = vObjectDirName and DocType = 'Zim Class' and FieldName = '_ZOFClassStructure' \
           evaluate ('')
         if $membercount = 0 and vZOMTarget like 'z%'
            %% There is no explicit name defined so build one from the DocName
            compute 1 Documents \
              where DocName = vZOMTarget and DirName = vObjectDirName and DocType = 'Zim Class' \
              evaluate (let vlZOFStructure = $replace(DocName, 1, 1, 'a'))
            if vlZOFStructure > ''
               let <NewZOFStructure> = vlZOFStructure \
                   <ZOFStructure> = $replace(vObjectName, 1, 1, 'a')
               rename form entity #<ObjDirName>.#<ZOFStructure> as #<NewZOFStructure> in #<ObjDirName>
           endif
        endif
      endif
   endif

   if $LastErrCode is not $null
      pZOMPostError($LastErrCode, "Error renaming object '#<ObjectName>'" )
      let $LastErrCode = $null
   endif

ExitProc:
   SET RESTORE

endprocedure
